/* rgba2ppm 1/20/97 Monty */

#include <stdio.h>

int main(int argc,char *argv[]){
  FILE *outfile=stdout;
  FILE *infile=stdin;

  if(argc>1){
    infile=fopen(argv[1],"rb");
    if(infile==NULL){
      fprintf(stderr,"rgba2ppm: Unable to open input file.\n");
      exit(-1);
    }
  }

  /* We only bother writing the P6 portable pixmap variation */
  {
    int x,y,xi,yi;
    char test[8];
    
    fscanf(infile,"%7c",test);
    test[7]='\0';
    if(strcmp(test,"RGBA32 ")){
      fprintf(stderr,"rgba2ppm: input is not an RGBA32 file.\n");
      exit(-1);
    }
      
    fscanf(infile,"%d %d%*1c",&x,&y);
    fprintf(outfile,"P6\n# CREATOR: rgba2ppm 1/20/97\n%d %d\n%d\n",x,y,
	    (int)255);

    {
      int r,g,b,a;
      
      for(yi=0;yi<y;yi++){
	for(xi=0;xi<x;xi++){
	  r=(unsigned char)fgetc(infile);
	  g=(unsigned char)fgetc(infile);
	  b=(unsigned char)fgetc(infile);
	  a=(unsigned char)fgetc(infile);
	  r=(r*a+(255-a)*255)/255;
	  g=(g*a+(255-a)*255)/255;
	  b=(b*a+(255-a)*255)/255;
	  fprintf(outfile,"%c%c%c",(unsigned char)r,
		  (unsigned char)g,
		  (unsigned char)b);
	}
      }
    }
  }
  fclose(infile);
  fclose(outfile);
}    





