/* rgbafade 1/19/97 Monty */

/* x1,y1 x2,y2 trans levels */

#define R(x) (((x)>>16)&0xffL)
#define G(x) (((x)>>8)&0xffL)
#define B(x) ((x)&0xffL)

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>

int main(int argc,char *argv[]){
  FILE *outfile=stdout;
  FILE *infile=stdin;
  int i=1,x,y;
  float tc1,tc2,tc3,tc4;
  char test[8];

  /* First arg could be a filename */

  if(argc>1){
    if(!isdigit(argv[i][0]) && argv[i][0]!='.' && argv[i][0]!='-'){
      infile=fopen(argv[i],"rb");
      if(infile==NULL){
	fprintf(stderr,"rgbafade: Unable to open input file.\n");
	exit(-1);
      }
      i++;
      
    }
  }

  /* 0. or 0% is transparent, 1. or 100% is opaque */
  if(argc<4+i){
    fprintf(stderr,"rgbafade: Specify transparency at all corners (UL UR LL LR)"
	    ".\n");
    exit(-1);
  }

  if(argv[i][strlen(argv[i])-1]=='%')
    tc1=(atof(argv[i++]))/100.;
  else
    tc1=atof(argv[i++]);
  if(argv[i][strlen(argv[i])-1]=='%')
    tc2=(atof(argv[i++]))/100.;
  else
    tc2=atof(argv[i++]);
  if(argv[i][strlen(argv[i])-1]=='%')
    tc3=(atof(argv[i++]))/100.;
  else
    tc3=atof(argv[i++]);
  if(argv[i][strlen(argv[i])-1]=='%')
    tc4=(atof(argv[i++]))/100.;
  else
    tc4=atof(argv[i++]);

  fscanf(infile,"%7c",test);
  test[7]='\0';
  if(strcmp(test,"RGBA32 ")){
    fprintf(stderr,"rgbafade: input is not an RGBA32 file.\n");
    exit(-1);
  }
  
  fscanf(infile,"%d %d%*1c",&x,&y);

  {
    int xi,yi;
    long *r,*g,*b,*a;
    float *t1,*t2;
    long *rP,*gP,*bP,*aP;
    int ptr;
    float ydiv=1./y;

    r=rP=malloc(x*y*sizeof(long));
    g=gP=malloc(x*y*sizeof(long));
    b=bP=malloc(x*y*sizeof(long));
    a=aP=malloc(x*y*sizeof(long));
    t1=malloc(y*sizeof(float));
    t2=malloc(y*sizeof(float));

    for(yi=0;yi<y;yi++){
      ptr=x*yi;
      t1[yi]=tc3*yi*ydiv + tc1*(y-yi-1)*ydiv;
      t2[yi]=tc4*yi*ydiv + tc2*(y-yi-1)*ydiv;

      for(xi=0;xi<x;xi++){
	r[ptr]=(unsigned char)fgetc(infile);
	g[ptr]=(unsigned char)fgetc(infile);
	b[ptr]=(unsigned char)fgetc(infile);
	a[ptr]=(unsigned char)fgetc(infile);
	ptr++;
      }
    }

    fprintf(outfile,"RGBA32 %d %d\n",x,y);

    for(yi=0;yi<y;yi++){
      float xdiv=1./x;
      r=rP+yi*x;
      g=gP+yi*x;
      b=bP+yi*x;
      a=aP+yi*x;
      for(xi=0;xi<x;xi++){
	float percent=xi*xdiv;
	float trans=t2[yi]*percent + t1[yi]*(1-percent);
	a[xi]=rint(a[xi]*trans);
	if(a[xi]<0)a[xi]=0;
	if(a[xi]>255)a[xi]=255;
	fprintf(outfile,"%c%c%c%c",(unsigned char)r[xi],
		(unsigned char)g[xi],
	        (unsigned char)b[xi],
		(unsigned char)a[xi]);
	  
      }
    }
  }
  fclose(infile);
  fclose(outfile);
  return(0);
}    






